All Libraries | This Library | Package | Class | Use | Tree | Deprecated | Index | Grand Index | Help
|  | Query |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

*** This class is subject to change. ***

## com.sas.iquery.metadata.business.step.olap
Class DataItemMemberPropertiesFilter

    com.sas.iquery.metadata.business.step.olap.DataItemMemberPropertiesFilter

All Implemented Interfaces:
  Base, BusinessModelResourceReferencer, ModelItem, StepFilterInterface, StepInterface, UsabilityInterface, PropertyChangeListenee, com.sas.util.LocalizableToStringInterface, java.beans.PropertyChangeListener, java.lang.Cloneable, java.util.EventListener

    public class DataItemMemberPropertiesFilter

implements BusinessModelResourceReferencer

A step that filters member properties set on a data item based on a boolean expression. Once it is resolved, it will resolve to one of the following definition:

- For the filtering of a character value, the MDX should be:

filter([CUSTOMER].[CUSTIDENTITY].members, StrToVal([customer].currentmember.properties("education")) = "Masters")

- For the filtering of numeric values, the MDX should be:

filter([CUSTOMER].[CUSTIDENTITY].members, StrToVal( ([customer].currentmember.properties("sql footage")) > 2300), booleanFlag)

It is important in the implementation of the member property filter that the correct level is applied to the filter. For example:

FILTER({[CUSTOMER].[REGION].MEMBERS}, [CUSTOMER].currentmember.properties("Education") = "Masters") The above filter WILL NOT work because [REGION] is the top level but it DOES not have any member properties

FILTER({[CUSTOMER].[CUSTIDENTITY].MEMBERS}, [CUSTOMER].currentmember.properties("Education") = "Masters")'

The above filter WILL work because CUSTIDENTITY has the member property. The filter class only apply the property name, the operator, and the value of the property to filter on. It does not know what level has the property applied to it nor does it check.

See Also:
  `StepFilterInterface`, `BaseFilter`

Field Summary
`static java.lang.String` | `EVENT_COMPARISON_OPERATOR_CHANGED` Indication that operator on filter has been changed
`static java.lang.String` | `EVENT_MEMBER_PROPERTY_NAME_CHANGED` Indication that left expression of filter has been changed
`static java.lang.String` | `EVENT_RIGHT_EXPRESSION_CHANGED` Indication that right expression of filter has been changed

Fields inherited from class com.sas.iquery.metadata.business.step.olap.BaseFilter
`EVENT_ACTION_TYPE_CHANGED, EVENT_LOCALIZABLE_LABELS_CHANGED`

Fields inherited from interface com.sas.iquery.metadata.business.Base
`EVENT_OBJECT_DEFINITION_CHANGED`

Fields inherited from interface com.sas.iquery.metadata.business.step.StepFilterInterface
`APPEND_ACTION_TYPE, DIFFERENCE_ACTION_TYPE, INITIAL_ACTION_TYPE, INSERT_ACTION_TYPE, INTERSECT_ACTION_TYPE, PREPEND_ACTION_TYPE, SPECIAL_ACTION_TYPE, UNION_ACTION_TYPE`

Fields inherited from interface com.sas.iquery.metadata.business.ModelItem
`EVENT_OBJECT_PROPERTY_CHANGED`

Constructor Summary
`DataItemMemberPropertiesFilter()`
`DataItemMemberPropertiesFilter(java.lang.String memberPropertyName, ComparisonOperator operator, java.lang.Object value)` Set a filter based on the value of member property in a set

Method Summary
`java.lang.String` | `getMemberPropertyName()` Gets the Member property name for this filter.
`java.lang.String` | `getmemberPropertyNameExpression()` Deprecated. use #getMemberPropertyName()
`ComparisonOperator` | `getOperator()` This method returns the operator to be used for filtering.
`java.util.List<NonCalculatedValue>` | `getRightExpression()` Gets the right expression for this conditional expression.
`void` | `setMemberPropertyName(java.lang.String nameOfProperty)` Sets the member property name portion of this filter.
`void` | `setMemberPropertyNameExpression(java.lang.String nameOfProperty)` Deprecated. use #setMemberPropertyName(String)
`void` | `setOperator(ComparisonOperator operator)` This method defines the type of operator to use for filtering.
`void` | `setRightExpression(java.util.List<? extends NonCalculatedValue> values)` Sets the right expression portion of the conditional expression.

Methods inherited from class com.sas.iquery.metadata.business.step.olap.BaseFilter
`getActionType, getDisplayedText, getLevels, setActionType`

Methods inherited from interface com.sas.iquery.metadata.business.BusinessModelResourceReferencer
`getResources`

Methods inherited from interface com.sas.iquery.metadata.PropertyChangeListenee
`addListener, getListeners, removeListener`

Methods inherited from interface com.sas.iquery.metadata.business.UsabilityInterface
`getReasonsUnusable, isUsableInQuery`

Field Detail

### EVENT_MEMBER_PROPERTY_NAME_CHANGED

    public static final java.lang.String EVENT_MEMBER_PROPERTY_NAME_CHANGED

  Indication that left expression of filter has been changed

  See Also:
    Constant Field Values

### EVENT_RIGHT_EXPRESSION_CHANGED

    public static final java.lang.String EVENT_RIGHT_EXPRESSION_CHANGED

  Indication that right expression of filter has been changed

  See Also:
    Constant Field Values

### EVENT_COMPARISON_OPERATOR_CHANGED

    public static final java.lang.String EVENT_COMPARISON_OPERATOR_CHANGED

  Indication that operator on filter has been changed

  See Also:
    Constant Field Values

Constructor Detail

### DataItemMemberPropertiesFilter

    public DataItemMemberPropertiesFilter()

### DataItemMemberPropertiesFilter

    public DataItemMemberPropertiesFilter(@Nonnull
                                          java.lang.String memberPropertyName,
                                          @Nonnull
                                          ComparisonOperator operator,
                                          @Nonnull
                                          java.lang.Object value)

  Set a filter based on the value of member property in a set

  Parameters:
    `memberPropertyName` - of property to be checked.
    `operator` - used to compare.
    `value` - check for

Method Detail

### setMemberPropertyName

    public void setMemberPropertyName(java.lang.String nameOfProperty)

  Sets the member property name portion of this filter.

  Parameters:
    `nameOfProperty` -

### setMemberPropertyNameExpression

    public void setMemberPropertyNameExpression(java.lang.String nameOfProperty)

  Deprecated. use #setMemberPropertyName(String)

### getMemberPropertyName

    public java.lang.String getMemberPropertyName()

  Gets the Member property name for this filter.

  Returns:
    the member property name

### getmemberPropertyNameExpression

    public java.lang.String getmemberPropertyNameExpression()

  Deprecated. use #getMemberPropertyName()

### setOperator

    public void setOperator(ComparisonOperator operator)

  This method defines the type of operator to use for filtering.

  Parameters:
    `operator` - The type of operator to be used for filtering

### getOperator

    public ComparisonOperator getOperator()

  This method returns the operator to be used for filtering.

  Returns:
    The operator to be used for filtering

### setRightExpression

    public void setRightExpression(java.util.List<? extends NonCalculatedValue> values)

  Sets the right expression portion of the conditional expression. This is commonly a single ConstantExpression representing a constant value to be used in the expression, but could also be a more general expression or a list of StringExpressions representing Member Names.

  Parameters:
    `values` - right side of conditional expression

### getRightExpression

    public java.util.List<NonCalculatedValue> getRightExpression()

  Gets the right expression for this conditional expression. This is commonly a single ConstantExpression representing a constant value to be used in the expression, but could also be a more general expression or a list of StringExpressions representing Member Names.

  Returns:
    the right side expression.

*** This class is subject to change. ***

All Libraries | This Library | Package | Class | Use | Tree | Deprecated | Index | Grand Index | Help
|  | Query |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2009 SAS Institute Inc. All Rights Reserved.